? diff.txt
? partitioning.patch
Index: src/backend/catalog/Makefile
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/catalog/Makefile,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/backend/catalog/Makefile	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/catalog/Makefile	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 27,33 ****
  
  POSTGRES_BKI_SRCS = $(addprefix $(top_srcdir)/src/include/catalog/,\
  	pg_proc.h pg_type.h pg_attribute.h pg_class.h \
! 	pg_attrdef.h pg_constraint.h pg_inherits.h pg_index.h pg_operator.h \
  	pg_opfamily.h pg_opclass.h pg_am.h pg_amop.h pg_amproc.h \
  	pg_language.h pg_largeobject.h pg_aggregate.h pg_statistic.h \
  	pg_rewrite.h pg_trigger.h pg_listener.h pg_description.h pg_cast.h \
--- 27,33 ----
  
  POSTGRES_BKI_SRCS = $(addprefix $(top_srcdir)/src/include/catalog/,\
  	pg_proc.h pg_type.h pg_attribute.h pg_class.h \
! 	pg_attrdef.h pg_constraint.h pg_inherits.h pg_partition.h pg_index.h pg_operator.h \
  	pg_opfamily.h pg_opclass.h pg_am.h pg_amop.h pg_amproc.h \
  	pg_language.h pg_largeobject.h pg_aggregate.h pg_statistic.h \
  	pg_rewrite.h pg_trigger.h pg_listener.h pg_description.h pg_cast.h \
Index: src/backend/catalog/pg_inherits.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/catalog/pg_inherits.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.2.1
diff -c -r1.1.1.1 -r1.1.1.1.2.1
*** src/backend/catalog/pg_inherits.c	19 May 2009 06:59:32 -0000	1.1.1.1
--- src/backend/catalog/pg_inherits.c	8 Jun 2009 08:28:51 -0000	1.1.1.1.2.1
***************
*** 287,289 ****
--- 287,357 ----
  
  	return result;
  }
+ 
+ /*
+  * find_inheritance_parents
+  *
+  * Returns a list containing the OIDs of all relations which
+  * are *direct* parents of the relation with OID 'inhchild'.
+  *
+  * This method is a logical copy of find_inheritance_children
+  */
+ List *
+ find_inheritance_parents(Oid inhchild)
+ {
+ 	List	   *list = NIL;
+ 	Relation	relation;
+ 	HeapScanDesc scan;
+ 	HeapTuple	inheritsTuple;
+ 	Oid			parentrelid;
+ 	ScanKeyData key[1];
+ 
+ 	/*
+ 	 * XXX : Can skip the scan if pg_attribute shows the relation has no
+ 	 * inherited column.. not sure if that will be any faster
+ 	 */
+ 
+ 	ScanKeyInit(&key[0],
+ 				Anum_pg_inherits_inhrelid,
+ 				BTEqualStrategyNumber, F_OIDEQ,
+ 				ObjectIdGetDatum(inhchild));
+ 	relation = heap_open(InheritsRelationId, AccessShareLock);
+ 	scan = heap_beginscan(relation, SnapshotNow, 1, key);
+ 	while ((inheritsTuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
+ 	{
+ 		parentrelid = ((Form_pg_inherits) GETSTRUCT(inheritsTuple))->inhparent;
+ 		list = lappend_oid(list, parentrelid);
+ 	}
+ 	heap_endscan(scan);
+ 	heap_close(relation, AccessShareLock);
+ 	return list;
+ }
+ 
+ /*
+  * find_all_ancestors -
+  *		Returns a list of relation OIDs of all direct and indirect
+  *		parents of the specified relation; the returned list DOES NOT
+  *		include the specified child relation OID.
+  *
+  *	Code is a logical copy of find_all_inheritors; refer comments in that method.
+  */
+ List *
+ find_all_ancestors(Oid childrel)
+ {
+ 	List	   *rels_list;
+ 	ListCell   *l;
+ 
+ 	rels_list = find_inheritance_parents(childrel);
+ 
+ 	/* see comments in find_all_inheritors for how this foreach works */
+ 	foreach(l, rels_list)
+ 	{
+ 		Oid			currentrel = lfirst_oid(l);
+ 		List	   *currentParents;
+ 
+ 		currentParents = find_inheritance_parents(currentrel);
+ 		rels_list = list_concat_unique_oid(rels_list, currentParents);
+ 	}
+ 
+ 	return rels_list;
+ }
Index: src/backend/catalog/pg_operator.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/catalog/pg_operator.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/backend/catalog/pg_operator.c	19 May 2009 06:59:32 -0000	1.1.1.2
--- src/backend/catalog/pg_operator.c	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 35,41 ****
  #include "utils/syscache.h"
  
  
! static Oid OperatorGet(const char *operatorName,
  			Oid operatorNamespace,
  			Oid leftObjectId,
  			Oid rightObjectId,
--- 35,41 ----
  #include "utils/syscache.h"
  
  
! Oid OperatorGet(const char *operatorName,
  			Oid operatorNamespace,
  			Oid leftObjectId,
  			Oid rightObjectId,
***************
*** 127,133 ****
   *
   *		*defined is set TRUE if defined (not a shell)
   */
! static Oid
  OperatorGet(const char *operatorName,
  			Oid operatorNamespace,
  			Oid leftObjectId,
--- 127,133 ----
   *
   *		*defined is set TRUE if defined (not a shell)
   */
! Oid
  OperatorGet(const char *operatorName,
  			Oid operatorNamespace,
  			Oid leftObjectId,
Index: src/backend/commands/copy.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/commands/copy.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/backend/commands/copy.c	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/commands/copy.c	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 277,283 ****
  static bool CopyGetInt32(CopyState cstate, int32 *val);
  static void CopySendInt16(CopyState cstate, int16 val);
  static bool CopyGetInt16(CopyState cstate, int16 *val);
! 
  
  /*
   * Send copy start/stop messages for frontend copies.  These have changed
--- 277,284 ----
  static bool CopyGetInt32(CopyState cstate, int32 *val);
  static void CopySendInt16(CopyState cstate, int16 val);
  static bool CopyGetInt16(CopyState cstate, int16 *val);
! extern int GetPartitionsCount(Oid parentOid);
! extern List* GetPartitions(Oid parentOid);
  
  /*
   * Send copy start/stop messages for frontend copies.  These have changed
***************
*** 1401,1424 ****
  		bool	   *nulls;
  		HeapScanDesc scandesc;
  		HeapTuple	tuple;
  
  		values = (Datum *) palloc(num_phys_attrs * sizeof(Datum));
  		nulls = (bool *) palloc(num_phys_attrs * sizeof(bool));
  
! 		scandesc = heap_beginscan(cstate->rel, GetActiveSnapshot(), 0, NULL);
! 
! 		while ((tuple = heap_getnext(scandesc, ForwardScanDirection)) != NULL)
  		{
! 			CHECK_FOR_INTERRUPTS();
  
! 			/* Deconstruct the tuple ... faster than repeated heap_getattr */
! 			heap_deform_tuple(tuple, tupDesc, values, nulls);
  
- 			/* Format and send the data */
- 			CopyOneRowTo(cstate, HeapTupleGetOid(tuple), values, nulls);
  		}
  
! 		heap_endscan(scandesc);
  	}
  	else
  	{
--- 1402,1460 ----
  		bool	   *nulls;
  		HeapScanDesc scandesc;
  		HeapTuple	tuple;
+ 		List		*partitions = NULL;
+ 		ListCell	*partition = NULL;		
+ 		Relation    tmpRel;
  
  		values = (Datum *) palloc(num_phys_attrs * sizeof(Datum));
  		nulls = (bool *) palloc(num_phys_attrs * sizeof(bool));
  
! 		/* If we are operating on partitioned table, then copy data in all the partitions.*/
! 		if(GetPartitionsCount(RelationGetRelid(cstate->rel)) > 0)
  		{
! 			/* Get partitions for table, if any.*/
! 			partitions = GetPartitions(RelationGetRelid(cstate->rel));
! 
! 			foreach(partition, partitions)
! 			{
! 				tmpRel = heap_open((Oid)lfirst_oid(partition), AccessShareLock);
! 
! 				scandesc = heap_beginscan(tmpRel, GetActiveSnapshot(), 0, NULL);
! 
! 				while ((tuple = heap_getnext(scandesc, ForwardScanDirection)) != NULL)
! 				{
! 					CHECK_FOR_INTERRUPTS();
  
! 					/* Deconstruct the tuple ... faster than repeated heap_getattr */
! 					heap_deform_tuple(tuple, tupDesc, values, nulls);
! 
! 					/* Format and send the data */
! 					CopyOneRowTo(cstate, HeapTupleGetOid(tuple), values, nulls);
! 				}
! 
! 				heap_endscan(scandesc);
! 
! 				heap_close(tmpRel, AccessShareLock);
! 			}
  
  		}
+ 		else
+ 		{
+ 			scandesc = heap_beginscan(cstate->rel, GetActiveSnapshot(), 0, NULL);
+ 
+ 			while ((tuple = heap_getnext(scandesc, ForwardScanDirection)) != NULL)
+ 			{
+ 				CHECK_FOR_INTERRUPTS();
+ 
+ 				/* Deconstruct the tuple ... faster than repeated heap_getattr */
+ 				heap_deform_tuple(tuple, tupDesc, values, nulls);
  
! 				/* Format and send the data */
! 				CopyOneRowTo(cstate, HeapTupleGetOid(tuple), values, nulls);
! 			}
! 
! 			heap_endscan(scandesc);
! 		}
  	}
  	else
  	{
***************
*** 2109,2115 ****
--- 2145,2165 ----
  			newtuple = ExecBRInsertTriggers(estate, resultRelInfo, tuple);
  
  			if (newtuple == NULL)		/* "do nothing" */
+ 			{
  				skip_tuple = true;
+ 			}
+ 			else if((newtuple->t_len == -1) || (newtuple->t_len == -2))
+ 			{
+ 				/* If this is partitioned table we are operating on and we receive 
+ 				a dummy row signalling that row has been inserted into appropriate partition
+ 				after constraints evaluation, mark it done and do nothing. */
+ 				if(GetPartitionsCount(RelationGetRelid(cstate->rel)) > 0)
+ 				{
+ 					heap_freetuple(tuple);
+ 					cstate->processed++;
+ 					skip_tuple = true;
+ 				}
+ 			}
  			else if (newtuple != tuple) /* modified by Trigger(s) */
  			{
  				heap_freetuple(tuple);
